﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default1.aspx.cs" Inherits="Default1" %>

<%@ Register TagPrefix="sw" Namespace="ActiveReports.Server.ReportControls" Assembly="ActiveReports.Server.ReportControls" %>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head runat="server">
	<meta http-equiv="X-UA-Compatible" content="IE=edge requiresActiveX=true" />
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1.0, user-scalable=no">
	<title>ActiveReports 12 Server</title>

	<!-- Cross-platform favicon -->
	<link rel="apple-touch-icon" sizes="57x57" href="portal/img/icons/apple-touch-icon-57x57.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="60x60" href="portal/img/icons/apple-touch-icon-60x60.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="72x72" href="portal/img/icons/apple-touch-icon-72x72.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="76x76" href="portal/img/icons/apple-touch-icon-76x76.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="114x114" href="portal/img/icons/apple-touch-icon-114x114.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="120x120" href="portal/img/icons/apple-touch-icon-120x120.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="144x144" href="portal/img/icons/apple-touch-icon-144x144.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="152x152" href="portal/img/icons/apple-touch-icon-152x152.png?v=11-jxwrbwnXGZ">
	<link rel="apple-touch-icon" sizes="180x180" href="portal/img/icons/apple-touch-icon-180x180.png?v=11-jxwrbwnXGZ">
	<link rel="manifest" href="portal/img/icons/manifest.json?v=11-jxwrbwnXGZ">
	<link rel="icon" href="portal/favicon.ico">
	<meta name="apple-mobile-web-app-title" content="ActiveReports">
	<meta name="application-name" content="ActiveReports">
	<meta name="msapplication-TileColor" content="#3c5087">
	<meta name="msapplication-TileImage" content="portal/img/icons//mstile-144x144.png?v=11-jxwrbwnXGZ">
	<meta name="theme-color" content="#ffffff">
	<!-- /.Cross-platform favicon -->

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="cache-control" content="no-cache" />
	<meta http-equiv="pragma" content="no-cache" />
	
	<style type="text/css">
		body, html {
			height: 100%;
		}	

		body {
			margin: 0px;
			overflow: hidden;
		}

		img {
			border: 0px;
		}

		.noflash #designerForm {
			display: none;
		}

		.viewer {
			height: 100%; 
			width: 100%; 
			display: inline-block;
		}

		.viewerTitle {
			text-align: center;
		}

		.toolbar {
			min-width: 100%;
			height: initial;
			display:inline-flex;
		}
		.toolbar .btn-group {
			display:inline-flex;
		}
	</style>

	<link rel="stylesheet" href="portal/css/bootstrap.min.css">
	<link rel="stylesheet" href="portal/css/bootstrap-datetimepicker.css">
	<link rel="stylesheet" href="portal/css/font-awesome.min.css">
	<script src="portal/js/vendor/jquery-2.1.0.min.js"></script>
	<script src="portal/js/vendor/jquery.cookie.min.js"></script>
	<script src="portal/js/vendor/jquery.livequery.js"></script>
	<script src="portal/js/vendor/bootstrap-3.1.1.min.js"></script>
	<script src="portal/js/vendor/knockout-3.1.0.min.js"></script>
	<script src="portal/js/vendor/bootstrap-datetimepicker.js"></script>
	<script src="portal/js/vendor/locales/bootstrap-datetimepicker.ja.js"></script>
	<script src="portal/js/vendor/locales/bootstrap-datetimepicker.zh-CN.js"></script>
	<script src="portal/js/vendor/modernizr.js"></script>
	<script src="portal/js/vendor/url.js"></script>
	<script src="pptx/jszip.min.js"></script>
	<script src="pptx/pptxgen.js"></script>
	<%# IsJSViewerPreviewMode ? 
	"<script src =\"portal/viewer/GrapeCity.ActiveReports.ReactViewer.min.js\"></script>" +
	"<link rel=\"stylesheet\" href=\"portal/css/materialdesignicons.min.css\">"
	:
	"<script src=\"portal/viewer/GrapeCity.ActiveReports.Viewer.Html.min.js\"></script>" +
	"<link rel=\"stylesheet\" href=\"portal/viewer/GrapeCity.ActiveReports.Viewer.Html.css\">"
	%>

	
	<script type="text/javascript">
		function checkIfFlashEnabled() {
			var isFlashEnabled = false;
			// Check for all browsers except IE 
			if (typeof (navigator.plugins) != "undefined"
				&& typeof (navigator.plugins["Shockwave Flash"]) == "object"
			) {
				isFlashEnabled = true;
			} else if (typeof window.ActiveXObject != "undefined") {
				// Check for IE 
				try {
					if (new ActiveXObject("ShockwaveFlash.ShockwaveFlash")) {
						isFlashEnabled = true;
					}
				} catch (e) { };
			};
			return isFlashEnabled;
		}

		var hasPendingChanges = false;

		window.onbeforeunload = function () {
			if (hasPendingChanges) {
				return "Report has unsaved changes.";
			}
		}

		function setHasPendingChanges(value) {
			hasPendingChanges = (value.toLowerCase() === "true");
		}
	</script>	
</head>
<body scroll='no' <%= IsHtml5PreviewMode || IsJSViewerPreviewMode ? "" : "class=\"flash-preview\"" %> >
<button id="pptx">pptx</button>
	<script>

var downloadReport = function (uri) { 
  var newWin = null; 
  // open uri in new window 
  try { newWin = window.open(uri); } catch (e) { } 
  // if browser rejects opening new window, open uri in current window 
  if (!newWin) { window.location = uri; } }; 

var isDocumentLoaded = false,viewer,
	documentLoadedHandler = function(){
		$('#pptx').on('click',function(){
			exportPptx(viewer);
		});
	};

function exportPptx(v){
	var pageCount = v.pageCount, pptx = new PptxGenJS();
	exportPptxByPage(v,pptx,pageCount,1);
}

function exportPptxByPage(v,pptx,pageCount,pageNumber){
	v.export('image',function(url){
		toDataUrl(url,function(base64){
			var slide = pptx.addNewSlide(), img = new Image();
			img.onload = function(){
				var w = img.width / 96, h = img.height /96;
				if(pageNumber == 1){
					pptx.setLayout({width:w, height:h });
				}
				slide.addImage({ x:0, y:0, w:w, h:h, data:base64});
				if(++pageNumber > pageCount) {
					pptx.save('jszip', function(blob){
						saveData(blob,'report.pptx');
					}, 'blob');
				}else{
					exportPptxByPage(v,pptx,pageCount,pageNumber);
				}
			};
			img.src = base64; 
		});
	}, true, { ImageType:'png',StartPage:pageNumber,EndPage:pageNumber});
}

function toDataUrl(url, callback) {
    var xhr = new XMLHttpRequest();
    xhr.onload = function() {
        var reader = new FileReader();
        reader.onloadend = function() {
            callback(reader.result);
        }
        reader.readAsDataURL(xhr.response);
    };
    xhr.open('GET', url);
    xhr.responseType = 'blob';
    xhr.send();
}

var saveData = (function () {
    var a = document.createElement("a");
    document.body.appendChild(a);
    a.style = "display: none";
    return function (blob, fileName) {
		var createObjectURL = window.URL.createObjectURL || window.webkitURL.createObjectURL,
		revokeObjectURL = window.URL.revokeObjectURL || window.webkitURL.revokeObjectURL;
        var url = createObjectURL(blob);
        a.href = url;
        a.download = fileName;
        a.click();
        revokeObjectURL(url);
    };
}());

		$(function () {

			var url = URL(document.URL);
			var action = (url.query.get('reportaction') || '').toLowerCase();
			if (action != "preview")
				return;

			var hasFlash = checkIfFlashEnabled();
			if (!hasFlash) {
				$("body").addClass("noflash");				
			}

			// do not load HTML viewer if flash preview is preffered
			if ($("body").is('.flash-preview') && hasFlash)
				return;
			
			$("body").append("<div id='_viewerTitle' class='viewerTitle'></div>");
			$("body").append("<div id='_viewer' class='viewer'></div>");

			var reportName = url.query.get('reportname');
			if (reportName) {
				var viewerTitle = $('#_viewerTitle');
				viewerTitle.text(decodeURIComponent(reportName));
				$('#_viewer').css('height', 'calc(99% - ' + viewerTitle.height() + 'px)');
			}

			var reportId = url.query.get('reportid');
			var snapshotId = url.query.get('snapshotid');
			var isMobile = url.query.get('mobile') == 1;

			var uiType = isMobile ? 'mobile' : 'desktop';
			var fromPortal = url.query.get('portal');

			var token = fromPortal
				? $.cookie('AuthToken')
				: $.cookie('AdminSiteAuthToken');

			var options = {
				baseUri: '.',
				localeUri: '<%=ResolveClientUrl("~/i18n?module=viewer")%>',
				element: '#_viewer', // id of element that will contain  the viewer
				uiType: uiType,
				reportService: {
					url: '<%=ResolveClientUrl("~/api/")%>',
					securityToken: token,
					resourceHandler: '<%=ResolveClientUrl("~/cache/")%>',
					pagingMode: 'Use paging'
				},
				report: { 'id': reportId, snapshotId: snapshotId },
				documentLoaded: documentLoadedHandler
			};
			
			<% if (IsJSViewerPreviewMode)
			   { %>
			createViewer(options);
			<% }
			   else
			   { %>

		viewer = GrapeCity.ActiveReports.Viewer(options);
			$(window).bind('beforeunload', function () {
				viewer.destroy();
			});
			
			   if (!Modernizr.inputtypes['datetime-local']) {
			$("input[type^=date]").livequery(
				function () {
					$(this).datetimepicker({
						minView: $(this).attr('type') == "date" ? 'month' : 'hour',
						language: navigator.language ? navigator.language.split('-')[0] : (navigator.userLanguage ? navigator.userLanguage.split('-')[0] : '')
					}).on('changeDate', function () {
						$(this).trigger("change");
					});
				});
			}
			<% } %>
		});
	</script>
	<% if (IncludeDesigner) { %>
	<form id="designerForm" runat="server" style="height:100%">			
			<div class="designer-host" style="height: 100%">
				<sw:Designer ID="_designer" runat="server" Width="100%" Height="100%"
					WindowMode="Opaque"
					RequestStatusCheckInterval="<%$ AppSettings:RequestStatusCheckInterval %>"
					ReportId="<%#ReportId%>"
					ReportName="<%#ReportName%>"
					ModelName="<%#ModelName%>"
					ReportAction="<%#ReportAction%>"
					SecurityToken="<%#SecurityToken%>"
					HiddenElements="<%#HiddenElements%>"
					SnapshotId="<%#SnapshotId%>"
					DesignerHelpPath="<%#DesignerHelpPath%>">
				</sw:Designer>
			</div>			
	</form>
	<% }  %>
</body>
</html>